#RAPTORRDP CONTROL SERVER 5.0
#created by "r3q13m" of SOLDIERX.COM
from twisted.internet import reactor, threads
from twisted.internet.task import LoopingCall
from twisted.internet.ssl import *
import io
import zlib
from OpenSSL import SSL
from autobahn.twisted.websocket import WebSocketServerProtocol, \
    WebSocketServerFactory, \
    listenWS

import random, string

def randomword(length):
   return ''.join(random.choice(string.lowercase) for i in range(length))

RAPTORFinstance = []

class ChainedOpenSSLContextFactory(DefaultOpenSSLContextFactory):
    def __init__(self, privateKeyFileName, certificateChainFileName,
                 sslmethod=SSL.TLSv1_METHOD):
        """
        @param privateKeyFileName: Name of a file containing a private key
        @param certificateChainFileName: Name of a file containing a certificate chain
        @param sslmethod: The SSL method to use
        """
        self.privateKeyFileName = privateKeyFileName
        self.certificateChainFileName = certificateChainFileName
        self.sslmethod = sslmethod
        self.cacheContext()
    
    def cacheContext(self):
        ctx = SSL.Context(self.sslmethod)
        ctx.use_certificate_chain_file(self.certificateChainFileName)
        ctx.use_privatekey_file(self.privateKeyFileName)
        self._context = ctx

class RAPTORFILE(WebSocketServerProtocol):

    def __init__(self):
        RAPTORFinstance.append(self)
    def onConnect(self, request):
        self.transport.setTcpNoDelay(True)
        print("Client connecting: {0}".format(request.peer))
    def onOpen(self):
        pass
    
    def onMessage(self, payload, isBinary):
        if isBinary:
            print("Binary message received: {0} bytes".format(len(payload)))
        else:
            #autobahn requires us to use utf8 encoding
            msg = payload.decode('utf8')
            com, data, arg = msg.split('[11111]')
            print com
            if com == ("[CONN]"):
                print data
                cur.execute("SELECT * FROM tickets")
                rows = cur.fetchall()
                for row in rows:
                    #you should modify these for your database system if you dont use ours.
                    if data == row[0]:
                        recpwd = hashlib.sha512(arg).hexdigest()
                        confirm = str(row[1])
                        if str(recpwd) == confirm:
                            clients[data] = self
                            for name, conn in clients.items():
                                if name == data:
                                    conn.sendMessage(('[RETCONN]'+'[00000]'+"[ACCEPTED!]").encode('utf8'))
                                    break
                            break
                        else:
                            self.transport.loseConnection()
            elif com == ("[IMAGE]"):
                try:
                    nametemp  = randomword(15)
                    w, h, d = arg.split("[22222]")
                    w = float(w)
                    h = float(h)
                    d = base64.b64decode(d)
                    d = zlib.decompress(d)
                    print (w,h)
                    image = pygame.image.frombuffer(d,(int(w),int(h)),"RGB")
                    pygame.image.save(image,"cache/"+nametemp+".png")
                    img = Image.open("cache/"+nametemp+".png")
                    b = io.BytesIO()
                    img.save(b,'PNG')
                    img_bytes = b.getvalue()
                    d = base64.b64encode(img_bytes)
                    arg = (str(w)+"[22222]"+str(h)+"[22222]"+d)
                    for name, conn in clients.items():
                        if name == data:
                            conn.sendMessage(('[IMAGE]'+'[00000]'+arg).encode('utf8'))
                            break
                except Exception as e:
                    print e
            elif com == ("[COMMAND]"):
                for name, conn in clients.items():
                    if name == data:
                        conn.sendMessage(('[COMMAND]'+'[00000]'+arg).encode('utf8'))
                        break
            elif com == ("[SCRREQ]"):
                for name, conn in clients.items():
                    if name == data:
                        conn.sendMessage(('[SCRREQ]'+'[00000]'+arg).encode('utf8'))
                        break
            elif com == ("[ALIVE]"):
                for name, conn in clients.items():
                    if name == data:
                        conn.sendMessage(('[ALIVE]'+'[00000]'+arg).encode('utf8'))
                        break

    def onClose(self, wasClean, code, reason):
        print("WebSocket connection closed: {0}".format(reason))

def CLEAN():
    try:
       os.system('rm cache/*.png')
    except:
       pass

if __name__ == '__main__':
    #we iternate over this dict for target client.
    clients = {}
    import sys
    import os
    from twisted.python import log
    import base64
    import pygame
    from pygame.locals import  *
    from PIL import Image
    import PIL
    from twisted.internet import reactor
    import sqlite3 as lite
    import hashlib
    from subprocess import Popen
    try:
        con = lite.connect('db/master.db')
        cur = con.cursor()
    except Exception as e:
        sys.exit()
    try:
       os.system("mount -t tmpfs -o size=512m tmpfs cache/")
    except Exception as e:
       print e
    log.startLogging(sys.stdout)
    contextFactory = ChainedOpenSSLContextFactory(
                privateKeyFileName="keys/server.key",
                certificateChainFileName="keys/server.pem",
                sslmethod = SSL.TLSv1_METHOD)
    factory = WebSocketServerFactory(u"wss://0.0.0.0:9000")
    factory.protocol = RAPTORFILE
    listenWS(factory, contextFactory)
    lc = LoopingCall(CLEAN)
    lc.start(300)
    reactor.run()
