#FILESERVER by r3q13m of soldierx.com v 4.1
from autobahn.twisted.websocket import WebSocketServerProtocol, \
    WebSocketServerFactory, \
    listenWS
from twisted.internet.ssl import *
from OpenSSL import SSL
import urllib
class ChainedOpenSSLContextFactory(DefaultOpenSSLContextFactory): #allows for using a full TLS chain. I forget where I got this.
    def __init__(self, privateKeyFileName, certificateChainFileName,
                 sslmethod=SSL.TLSv1_METHOD):
        """
        @param privateKeyFileName: Name of a file containing a private key
        @param certificateChainFileName: Name of a file containing a certificate chain
        @param sslmethod: The SSL method to use
        """
        self.privateKeyFileName = privateKeyFileName
        self.certificateChainFileName = certificateChainFileName
        self.sslmethod = sslmethod
        self.cacheContext()

    def cacheContext(self):
        ctx = SSL.Context(self.sslmethod)
        ctx.use_certificate_chain_file(self.certificateChainFileName)
        ctx.use_privatekey_file(self.privateKeyFileName)
        self._context = ctx


class RAPTORFILE(WebSocketServerProtocol):
    def __init__(self):
        self.mastername = ""

    def onConnect(self, request):
        print("Client connecting: {0}".format(request.peer))

    def onOpen(self):
        pass
    
    def onMessage(self, payload, isBinary):
        if isBinary:
            print("Binary message received: {0} bytes".format(len(payload)))
        else:
            msg = payload.decode('utf8')
            print msg
            com, data, arg = msg.split('[11111]')
            if com == ("[CONN]"):
                print data
                cur.execute("SELECT * FROM tickets")
                rows = cur.fetchall()
                for row in rows:
                    if data == row[0]:
                        recpwd = hashlib.sha512(arg).hexdigest()
                        confirm = str(row[1])
                        if str(recpwd) == confirm:
                            clients[data] = self
                            for name, conn in clients.items():
                                if name == data:
                                    conn.sendMessage(('[RETCONN]'+'[00000]'+"[ACCEPTED!]").encode('utf8'))
                                    break
                            break
                        else:
                            self.transport.loseConnection()

            elif com == ("[ALIVE]"):
                for name, conn in clients.items():
                    print name, conn
                    if name == data:
                       conn.sendMessage(('[ALIVE]'+'[00000]'+str(arg)).encode('utf8')) 
                        
            elif com == ("[TRANSVERSE]"):
                print (data + " " + arg)
                for name, conn in clients.items():
                    print name, conn
                    if name == data:
                        conn.sendMessage(('[TRANSVERSE]'+'[00000]'+str(arg)).encode('utf8'))
                        break
            elif com == ("[RETTRANS]"):
                print (data + " " + arg)
                for name, conn in clients.items():
                    print name, conn
                    if name == data:
                        conn.sendMessage(('[RETTRANS]'+'[00000]'+str(arg)).encode('utf8'))
                        break
            elif com == ("[LIST]"):
                print (data + " " + arg)
                for name, conn in clients.items():
                    print name, conn
                    if name == data:
                        conn.sendMessage(('[LIST]'+'[00000]'+str(arg)).encode('utf8'))
                        break
            elif com == ("[RETLIST]"):
                print (data + " " + arg)
                for name, conn in clients.items():
                    print name, conn
                    if name == data:
                        conn.sendMessage(('[RETLIST]'+'[00000]'+str(arg)).encode('utf8'))
                        break
            elif com == ("[DOWNLOAD]"):
                print (data)
                for name, conn in clients.items():
                    print name, conn 
                    if name == data:
                        conn.sendMessage(('[DOWNLOAD]'+'[00000]'+str(arg)).encode('utf8'))


            elif com == ("[RETDOWN]"):
                for name, conn in clients.items():
                    print name, conn
                    if name == data:
                        code, target, d = msg.split('[11111]')
                        filecode, filedata = d.split('[22222]')
                        if filecode == "[FILE TRANSFER COMPLETE]":
                            conn.sendMessage(('[RETDOWN]'+'[00000]'+filecode+'[22222]'+self.mastername+'[22222]'+ "https://anacondasoft.com/filesystem/"+target+"/"+self.mastername).encode('utf8'))
                            break
                        else:
                            if os.path.isdir("/var/www/html/filesystem/"+target):
                                try:
                                    filedata = base64.b64decode(filedata)
                                    open("/var/www/html/filesystem/"+target+"/"+filecode,'ab').write(filedata)
                                    self.mastername = filecode
                                except Exception as e:
                                    print e
                            else:
                                try:
                                    os.makedirs("/var/www/html/filesystem/"+target)
                                    filedata = base64.b64decode(filedata)
                                    open("/var/www/html/filesystem/"+target+"/"+filecode,'ab').write(filedata)
                                    self.mastername = filecode
                                except Exception as e:
                                    print e

            elif com == ("[UPLOAD]"):
                for name, conn in clients.items():
                    print name, conn
                    if name == data:
                        code, target, d = msg.split('[11111]')
                        filecode, filedata = d.split('[22222]')
                        if filecode == "[FILE TRANSFER COMPLETE]":
                            conn.sendMessage(('[UPLOAD]'+'[00000]'+filecode+'[22222]'+self.mastername+'[22222]'+ "https://anacondasoft.com/filesystem/"+target+"/"+self.mastername).encode("utf8"))
                            break
                        else:
                            if os.path.isdir("/var/www/html/filesystem/"+target):
                                try:
                                    filedata = base64.b64decode(filedata)
                                    open("/var/www/html/filesystem/"+target+"/"+filecode,'ab').write(filedata)
                                    self.mastername = filecode
                                except Exception as e:
                                    print e
                            else:
                                try:
                                    os.makedirs("/var/www/html/filesystem/"+target)
                                    filedata = base64.b64decode(filedata)
                                    open("/var/www/html/filesystem/"+target+"/"+filecode,'ab').write(filedata)
                                    self.mastername = filecode
                                except Exception as e:
                                    print e
            elif com == ("[PURGE]"):
                try:
                    code, nm, file = msg.split("[11111]")
                    print code
                    print nm
                    print file
                    os.remove("/var/www/html/filesystem/"+nm+"/"+file)
                except Exception as e:
                    print e
                    
    def onClose(self, wasClean, code, reason):
        print("WebSocket connection closed: {0}".format(reason))


if __name__ == '__main__':
    clients = {}
    import sys
    import os
    from twisted.python import log
    from twisted.internet import reactor
    import sqlite3 as lite
    import hashlib
    import base64
    try:
        con = lite.connect('db/master.db')
        cur = con.cursor()
    except Exception as e:
        sys.exit()

    log.startLogging(sys.stdout)
    #READ THESE LINES NERDS 
    contextFactory = ChainedOpenSSLContextFactory(
                privateKeyFileName="keys/server.key",
                certificateChainFileName="keys/server.pem",
                sslmethod = SSL.TLSv1_METHOD)
    factory = WebSocketServerFactory(u"wss://0.0.0.0:10000")
    factory.protocol = RAPTORFILE
    listenWS(factory, contextFactory)
    reactor.run()
