#dirmanager.py 8.0 FINAL
from autobahn.twisted.websocket import WebSocketClientProtocol, \
    WebSocketClientFactory, \
    connectWS

#we upload files in websocket but download them in http. this is due to limitations of the javascript client.
import urllib

#these instances are used to allow classes to talk to each other in a faster way.
instance = []
fminstance = []

class File_Manager():
    def __init__(self, master=None):
        fminstance.append(self) # I append the class to the fminstance list. this allows me to access its methods in a for loop from anywhere.
        # Set background of toplevel window to match
        # current style
        style = ttk.Style()
        theme = style.theme_use()
        default = style.lookup(theme, 'background')
        master.configure(background=default)

        self.menubar = Menu(master,font="Helvetica 12",bg='#d9d9d9',fg='#000000')
        master.configure(menu = self.menubar)

        self.file = Menu(master,tearoff=0)
        self.menubar.add_cascade(menu=self.file,
                activebackground="#d9d9d9",
                activeforeground="#000000",
                background="#d9d9d9",
                font="Helvetica 12",
                foreground="#000000",
                label="File")
        self.file.add_command(
                activebackground="#d9d9d9",
                activeforeground="#000000",
                background="#d9d9d9",
                command=self.QUIT,
                font="Helvetica 12",
                foreground="#000000",
                label="Quit")


        self.Scrolledtext1 = Text (master)
        self.Scrolledtext1.place(relx=0.0,rely=0.04,relheight=0.87
                ,relwidth=0.49)
        self.Scrolledtext1.configure(selectbackground="#c4c4c4")

        self.Scrolledtext2 = Text (master)
        self.Scrolledtext2.place(relx=0.52,rely=0.04,relheight=0.87
                ,relwidth=0.49)
        self.Scrolledtext2.configure(selectbackground="#c4c4c4")

        self.Button1 = Button (master)
        self.Button1.place(relx=0.0,rely=0.93,height=26,width=77)
        self.Button1.configure(command=self.LCD)
        self.Button1.configure(text='''Change Dir''')

        self.Button2 = Button (master)
        self.Button2.place(relx=0.18,rely=0.93,height=26,width=68)
        self.Button2.configure(command=self.LLS)
        self.Button2.configure(text='''List Dir''')

        self.Button3 = Button (master)
        self.Button3.place(relx=0.37,rely=0.93,height=26,width=67)
        self.Button3.configure(command=self.upload)
        self.Button3.configure(text='Upload')

        self.Button4 = Button (master)
        self.Button4.place(relx=0.52,rely=0.93,height=26,width=77)
        self.Button4.configure(command=self.RCD)
        self.Button4.configure(text='''Change Dir''')

        self.Button5 = Button (master)
        self.Button5.place(relx=0.7,rely=0.93,height=26,width=68)
        self.Button5.configure(command=self.RLS)
        self.Button5.configure(text='List Dir')

        self.Button6 = Button (master)
        self.Button6.place(relx=0.88,rely=0.93,height=26,width=67)
        self.Button6.configure(command=self.download)
        self.Button6.configure(text='Download')
        
        self.factory = WebSocketClientFactory("wss://"+sys.argv[1]+":10000") ##Pretty self explanatory I take sys.argv[1] and pass it to the websocket
        self.factory.protocol = RAPTORFILE
        
        self.contextFactory = ssl.ClientContextFactory()
        connectWS(self.factory, self.contextFactory)
        
        reactor.run()
    def destroy_File_Manager(self):
        os._exit(1)
    def QUIT(self):
        self.destroy_File_Manager()

    def LCD(self):
        def callback():
            s = v.get()
            if sys.platform.startswith('linux'):
                os.chdir(s)
                x = Popen(["ls", "-l"],shell=False,stdout=PIPE,stderr=PIPE)
            elif sys.platform.startswith('darwin'):
                os.chdir(s)
                x = Popen(["ls", "-l"],shell=False,stdout=PIPE,stderr=PIPE)
            elif sys.platform.startswith('win32'):
                os.chdir(s)
                x = Popen(['dir'], shell=True, stdout=PIPE, stderr=PIPE)
            self.Scrolledtext1.delete(1.0, END)
            self.Scrolledtext1.insert(END,x.stdout.read())
        v = StringVar()
        toplevel = Toplevel()
        label1 = Label(toplevel, text="Change Directory to: " , height=0, width=100)
        label1.pack()
        entry1 = Entry(toplevel, textvariable=v)
        entry1.pack()
        b = Button(toplevel, text="OK", command=callback)
        b.pack()

    def LLS(self):
        if sys.platform.startswith('win32'):
            x = Popen(['dir'], shell=True, stdout=PIPE, stderr=PIPE)
            self.Scrolledtext1.delete(1.0, END)
            self.Scrolledtext1.insert(END,x.stdout.read())
        elif sys.platform.startswith('linux'):
            x = Popen(['ls', '-l'], shell=False, stdout=PIPE, stderr=PIPE)
            self.Scrolledtext1.delete(1.0, END)
            self.Scrolledtext1.insert(END,x.stdout.read())
        elif sys.platform.startswith('darwin'):
            x = Popen(['ls', '-l'], shell=False, stdout=PIPE, stderr=PIPE)
            self.Scrolledtext1.delete(1.0, END)
            self.Scrolledtext1.insert(END,x.stdout.read())

    def RCD(self):
        def callback():
            s = v.get()
            for i in instance: # example calling the socket class from the GUI class using global list
                self.factory.protocol.sendMessage(i,('[TRANSVERSE]'+"[11111]"+rid+"[11111]"+s).encode('utf8'))
        v = StringVar()
        toplevel = Toplevel()
        label1 = Label(toplevel, text="Change Directory to: " , height=0, width=100)
        label1.pack()
        entry1 = Entry(toplevel, textvariable=v)
        entry1.pack()
        b = Button(toplevel, text="OK", command=callback)
        b.pack()

    def RLS(self):
        for i in instance:
            self.factory.protocol.sendMessage(i,('[LIST]'+"[11111]"+rid+"[11111]"+"[NULL]").encode('utf8'))

    def download(self):
        def callback():
            s = v.get()
            for i in instance:
                self.factory.protocol.sendMessage(i,('[DOWNLOAD]'+"[11111]"+rid+"[11111]"+s).encode('utf8'))
        v = StringVar()
        toplevel = Toplevel()
        label1 = Label(toplevel, text="Download File : " , height=0, width=100)
        label1.pack()
        entry1 = Entry(toplevel, textvariable=v)
        entry1.pack()
        b = Button(toplevel, text="OK", command=callback)
        b.pack()

    def upload(self):
        def callback():
            def read_in_chunks(file_object, chunk_size=4096):
                """Lazy function (generator) to read a file piece by piece.
                Default chunk size: 1k."""
                while True:
                    chunk = file_object.read(chunk_size)
                    if not chunk:
                        break
                    yield chunk
            s = v.get()
            f = open(s,"rb")
            x = os.path.basename(s)
            for i in instance:
                for piece in read_in_chunks(f):
                    self.factory.protocol.sendMessage(i,("[UPLOAD]"+"[11111]"+rid+"[11111]"+ x + "[22222]"+ base64.b64encode(piece)).encode('utf8'))
                self.factory.protocol.sendMessage(i,("[UPLOAD]"+"[11111]"+rid+"[11111]"+ "[FILE TRANSFER COMPLETE]" + "[22222]"+ "[NULL]").encode('utf8'))
            self.Scrolledtext1.delete(1.0, END)
            self.Scrolledtext1.insert(END,str("[FILE UPLOAD ACTIVE!]"))
        v = StringVar()
        toplevel = Toplevel()
        label1 = Label(toplevel, text="Upload file: " , height=0, width=100)
        label1.pack()
        entry1 = Entry(toplevel, textvariable=v)
        entry1.pack()
        b = Button(toplevel, text="OK", command=callback)
        b.pack()
class RAPTORFILE(WebSocketClientProtocol):
    
    def onConnect(self, response):
        instance.append(self) #we append this class to the other global list
        print("Server connected: {0}".format(response.peer))
        self.sendMessage(("[CONN]"+"[11111]"+lid+"[11111]"+passwd).encode('utf8')) # this is what our standard CONN sequence looks like. IT must send the local userid and the password for localuser and check it against the database.

    def onOpen(self):
        print("WebSocket connection open.")

    def onMessage(self, payload, isBinary):
        if isBinary:
            print("Binary message received: {0} bytes".format(len(payload)))
        else:
            msg = payload.decode('utf8')
            print msg
            com, data = msg.split("[00000]") #00000 is a server side split code universally along with 22222 which is parsed later, 22222 however can also be sent from clients.
            if com == ("[RETLIST]"):
                for i in fminstance:#example calling the gui class from global list and injecting data
                    i.Scrolledtext2.delete(1.0, END)
                    i.Scrolledtext2.insert(END,data)
            elif com == ("[RETTRANS]"):
                for i in fminstance:
                    i.Scrolledtext2.delete(1.0, END)
                    i.Scrolledtext2.insert(END,data)
            elif com == ("[RETDOWN]"):
                if ("[FILE TRANSFER COMPLETE]") in data:
                    code, name, info = data.split("[22222]")
                    urllib.urlretrieve(info,name)
                    self.sendMessage(('[PURGE]'+"[11111]" + lid + "[11111]" + name).encode('utf8'))
                    for i in fminstance:
                        i.Scrolledtext2.delete(1.0, END)
                        i.Scrolledtext2.insert(END,name)
                else:
                    pass
            elif com == ("[RETCONN]"):
                print (data)

    def onClose(self, wasClean, code, reason):
        print("WebSocket connection closed: {0}".format(reason))

class main():
    def __init__(self):
        self.root = Tk()
        self.root.title('File_Manager')
        self.root.geometry('600x450+372+105')
        tksupport.install(self.root)
        self.w = File_Manager (self.root)
        self.root.protocol("WM_DELETE_WINDOW", self.w.destroy_File_Manager)
        log.startLogging(sys.stdout)

if __name__ == '__main__':
    from Tkinter import *
    from subprocess  import Popen, PIPE
    import ttk
    import sys
    import base64
    import os
    from twisted.python import log
    from twisted.internet import reactor, ssl
    from twisted.internet import tksupport
    lid = sys.argv[2]
    rid = sys.argv[3]
    passwd = sys.argv[4]
    main()
